; Sketchy Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the Sketchy distribution
; for conditions of use.

; ---name---
; subst

; ---conformance---
; R5RS

; ---purpose---
; Substitute
; .V x
; for each occurence of
; .V y
; in
; .V z.
; .V X, y, z
; are S-expressions.

; ---args---
; X - expression to replace Y with
; Y - expression to find
; Z - expression to process

; ---keywords---
; SUBST function, substitution, substitute, lists

; ---example---
; (subst 'z 'y '(lambda (x y) (x y))) => (lambda (x z) (x z))

;require lib/equalp.l equal?
;require lib/append.l
;require lib/reverse.l
;require lib/caar.l cdar

; ---code---
(define (subst x y z)
  (cond ((equal? y z) x)
    ((pair? z)
      (cons (subst x y (car z))
            (subst x y (cdr z))))
    (#t z)))

