; Sketchy Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the Sketchy distribution
; for conditions of use.

; ---name---
; vqueens

; ---conformance---
; R5RS

; ---purpose---
; Pretty-print a solution of the N-queens problem.

; ---args---
; BOARD-SIZE - size of the board.
; SOLUTION - solution produces by QUEENS.

; ---keywords---
; VQUEENS function, queens, eight queens, N queens, N-queens, example

; ---example---
; :require src/queens.l
; (vqueens 4 (queens 4)) => done
; ; output:

;require lib/zerop.l zero?
;require lib/newline.l
;require lib/minus.l -
;require lib/remainder.l

; ---code---
(define (vqueens board-size solution)
  (letrec

    ((print-dots (lambda (n)
      (cond ((zero? n) ())
        (#t (begin
              (display " .")
              (print-dots (- n 1)))))))

    (print-row (lambda (n)
      (begin
        (print-dots n)
        (display " &")
        (print-dots (- board-size n 1))
        (newline))))

    (print-board (lambda (b)
      (cond ((null? b) 'done)
        (#t (begin
              (print-row
                (remainder (car b) board-size))
              (print-board (cdr b))))))))

    (print-board solution)))

